mklive.sh.in 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2009-2012 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. # vim: set ts=4 sw=4 et:
  27. trap "echo; error_out $?" INT QUIT
  28. CHROOT_CMD="linux-user-chroot --unshare-ipc --unshare-pid --unshare-net \
  29. --mount-bind /dev /dev --mount-bind /sys /sys --mount-proc /proc"
  30. info_msg() {
  31. printf "\033[1m$@\n\033[m"
  32. }
  33. error_out() {
  34. info_msg "There was an error! cleaning up $BUILDDIR, exiting..."
  35. [ -d "$BUILDDIR" ] && rm -rf "$BUILDDIR"
  36. #[ -f "$LOGFILE" ] && rm -f "$LOGFILE"
  37. exit 1
  38. }
  39. write_etc_motd() {
  40. cat >> "$ROOTFS/etc/motd" <<_EOF
  41. ###############################################################################
  42. Autogenerated by void-mklive "@@MKLIVE_VERSION@@"
  43. -------------------------------------------------------------------------------
  44. Welcome to the Void Linux Live system, you have been autologged in.
  45. This user has full sudo(8) permissions without any password, be careful
  46. executing commands through sudo(8).
  47. To play with package management use the xbps-* utilities. Please visit:
  48. http://code.google.com/p/xbps/
  49. for more information and/or documentation about using the X Binary
  50. Package System. If you think it is useful, please make a donation
  51. to improve further development from the above URL, thanks.
  52. To start the installation please type:
  53. $ sudo void-installer
  54. and follow the on-screen instructions. Thanks for trying Void Linux.
  55. ###############################################################################
  56. _EOF
  57. }
  58. write_conf_file() {
  59. cat > "$1" <<_EOF
  60. # *-*- sh -*-*
  61. # Default configuration file for vmklive-@VERSION@.
  62. #
  63. # List of packages to be installed into the live image.
  64. # By default the 'base-system-live' pkg is always installed because
  65. # it is required to generate a working image.
  66. #PACKAGE_LIST="foo blah"
  67. # Syslinux splash image.
  68. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  69. # Default keymap to use.
  70. KEYMAP=us
  71. # Default locale to use.
  72. LOCALE=en_US.UTF-8
  73. # Path to XBPS utilities.
  74. #XBPS_INSTALL_CMD=xbps-install
  75. #XBPS_QUERY_CMD=xbps-query
  76. #XBPS_RECONFIGURE_CMD=xbps-reconfigure
  77. #XBPS_REMOVE_CMD=xbps-remove
  78. #XBPS_RINDEX_CMD=xbps-rindex
  79. #XBPS_UHELPER_CMD=xbps-uhelper
  80. # XBPS cache directory to install packages from.
  81. #REPOSITORY_CACHE=/blah/foo
  82. _EOF
  83. chmod 644 "$1"
  84. }
  85. usage()
  86. {
  87. cat <<_EOF
  88. Usage: $(basename $0) [options]
  89. Options:
  90. -C file Path to configuration file (defaults to ~/.mklive.conf)
  91. -c (gzip|bzip2|xz) Compression type for the squashfs/initramfs image.
  92. -l "pkgname ..." Generate a local repository in the image with these packages.
  93. Packages must be delimited by blanks.
  94. -r rootdir Use this directory to generate the image (if unset,
  95. current working directory will be used).
  96. -o outfile Output file name for the ISO image.
  97. -s splash Splash image file for isolinux.
  98. _EOF
  99. exit 1
  100. }
  101. install_packages() {
  102. for f in ${PACKAGE_LIST}; do
  103. info_msg " $f"
  104. done
  105. # Check that all pkgs are reachable.
  106. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -n xbps-git \
  107. ${PACKAGE_LIST} >>$LOGFILE 2>&1
  108. if [ $? -ne 0 ]; then
  109. info_msg "Missing required binary packages, exiting..."
  110. error_out
  111. fi
  112. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} xbps-git ${PACKAGE_LIST} >>$LOGFILE 2>&1
  113. [ $? -ne 0 ] && error_out $?
  114. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -u >>$LOGFILE 2>&1
  115. [ $? -ne 0 ] && error_out $?
  116. ${XBPS_REMOVE_CMD} ${XBPS_ARGS} -o >>$LOGFILE 2>&1
  117. [ $? -ne 0 ] && error_out $?
  118. ${XBPS_QUERY_CMD} -r "$ROOTFS" -l > \
  119. "${OUTPUT_FILE%.iso}"-package-list.txt || error_out
  120. # Reconfigure all pkgs again via linux-user-chroot.
  121. $CHROOT_CMD $ROOTFS xbps-reconfigure -fa >>$LOGFILE 2>&1
  122. }
  123. generate_initramfs() {
  124. # Install required pkgs in a temporary rootdir to create
  125. # the initramfs and to copy required files.
  126. $XBPS_INSTALL_CMD -r $ROOTFS/kernel_temp -y \
  127. base-system void-mklive >>$LOGFILE 2>&1
  128. # Install some required utilities from util-linux.
  129. install -Dm755 $ROOTFS/kernel_temp/usr/sbin/agetty \
  130. "$ROOTFS/usr/sbin/agetty" || error_out $?
  131. install -Dm755 $ROOTFS/kernel_temp/usr/bin/lsblk \
  132. "$ROOTFS/usr/bin/lsblk" || error_out $?
  133. $CHROOT_CMD $ROOTFS/kernel_temp dracut --no-hostonly \
  134. --add "dmsquash-live vmklive" --${COMPRESSTYPE} \
  135. "/boot/initrd.lz" 2>/dev/null || error_out
  136. mv $ROOTFS/kernel_temp/boot/initrd.lz $BOOT_DIR
  137. # We rely on pam now, so let's install the host login config.
  138. install -Dm644 $ROOTFS/kernel_temp/etc/pam.d/login \
  139. "$ROOTFS/etc/pam.d/login" || error_out $?
  140. }
  141. copy_kernel_and_modules() {
  142. cp -a $ROOTFS/kernel_temp/boot/vmlinuz-${KERNELVERSION} \
  143. $BOOT_DIR/vmlinuz
  144. mkdir -p $ROOTFS/lib/modules
  145. cp -a $ROOTFS/kernel_temp/lib/modules/${KERNELVERSION} \
  146. $ROOTFS/lib/modules
  147. # remove temporary rootfs.
  148. rm -rf $ROOTFS/kernel_temp
  149. }
  150. generate_local_repository() {
  151. mkdir -p $ROOTFS/packages
  152. pkgs=$($XBPS_INSTALL_CMD -s -r /tmp/blah -n ${LOCALREPO_PKGLIST})
  153. set -- ${pkgs}
  154. while [ $# -ne 0 ]; do
  155. pkgn=$1; action=$2; ver=$3; repo=$4; binpkg=$5; arch=$6
  156. shift 6
  157. bpkg=$repo/$arch/$binpkg
  158. cp -f $bpkg $ROOTFS/packages
  159. done
  160. $XBPS_RINDEX_CMD -a $ROOTFS/packages/*.xbps 2>&1 >>$LOGFILE
  161. rm -f $ROOTFS/packages/index-files.plist
  162. }
  163. generate_isolinux_boot() {
  164. cp -f $SYSLINUX_DATADIR/isolinux.bin "$ISOLINUX_DIR" || error_out $?
  165. cp -f $SYSLINUX_DATADIR/vesamenu.c32 "$ISOLINUX_DIR" || error_out $?
  166. cp -f $MKLIVE_DATADIR/isolinux.cfg.in \
  167. "$ISOLINUX_DIR"/isolinux.cfg || error_out $?
  168. if [ -f "$SPLASH_IMAGE" ]; then
  169. cp -f $SPLASH_IMAGE "$ISOLINUX_DIR" || error_out $?
  170. fi
  171. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  172. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  173. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  174. -e "s|@@ARCH@@|$(uname -m)|" \
  175. -e "s|@@LOCALE@@|${LOCALE}|" $ISOLINUX_DIR/isolinux.cfg
  176. }
  177. generate_grub_efi_boot() {
  178. cp -f $MKLIVE_DATADIR/grub.cfg $GRUB_DIR || error_out $?
  179. cp -f $MKLIVE_DATADIR/grub_void.cfg.in \
  180. $GRUB_DIR/grub_void.cfg || error_out $?
  181. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  182. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  183. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  184. -e "s|@@ARCH@@|$(uname -m)|" \
  185. -e "s|@@LOCALE@@|${LOCALE}|" $GRUB_DIR/grub_void.cfg
  186. mkdir -p $GRUB_DIR/fonts $GRUB_DIR/locale || error_out $?
  187. cp -f $GRUB_DATADIR/unicode.pf2 $GRUB_DIR/fonts || error_out $?
  188. cp -f /boot/grub/locale/* $GRUB_DIR/locale || error_out $?
  189. # Create EFI vfat image.
  190. dd if=/dev/zero of=$GRUB_DIR/efiboot.img bs=1024 count=4096 \
  191. >>$LOGFILE 2>&1 || error_out $?
  192. mkfs.vfat -F12 -S 512 -n "grub_uefi" "$GRUB_DIR/efiboot.img" \
  193. >>$LOGFILE 2>&1 || error_out $?
  194. GRUB_EFI_TMPDIR="$(mktemp --tmpdir=$HOME -d)"
  195. LOOP_DEVICE="$(losetup --show --find ${GRUB_DIR}/efiboot.img)"
  196. mount -o rw,flush -t vfat "${LOOP_DEVICE}" "${GRUB_EFI_TMPDIR}" \
  197. >>$LOGFILE 2>&1 || error_out $?
  198. mkdir -p "${GRUB_EFI_TMPDIR}/EFI/boot/" || error_out $?
  199. cd "$BUILDDIR" || error_out $?
  200. grub-mkstandalone --directory="/usr/lib/grub/x86_64-efi" \
  201. --format="x86_64-efi" \
  202. --compression="xz" --output="${GRUB_EFI_TMPDIR}/EFI/boot/bootx64.efi" \
  203. "boot/grub/grub.cfg" >>$LOGFILE 2>&1 || error_out $?
  204. umount "$GRUB_EFI_TMPDIR" || error_out $?
  205. losetup --detach "${LOOP_DEVICE}" || error_out $?
  206. rm -rf $GRUB_EFI_TMPDIR || error_out $?
  207. }
  208. generate_squashfs() {
  209. # Find out required size for the rootfs and create an ext3fs image off it.
  210. ROOTFS_SIZE=$(du -sk "$ROOTFS"|awk '{print $1}')
  211. mkdir -p "$BUILDDIR/tmp/LiveOS"
  212. dd if=/dev/zero of="$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  213. bs="$((${ROOTFS_SIZE}+($ROOTFS_SIZE/6)))K" count=1 \
  214. >>$LOGFILE 2>&1 || error_out $?
  215. mkdir -p "$BUILDDIR/tmp-rootfs"
  216. mkfs.ext3 -F -m1 "$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  217. >>$LOGFILE 2>&1 || error_out $?
  218. mount -o loop "$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  219. "$BUILDDIR/tmp-rootfs" || error_out $?
  220. cd $BUILDDIR
  221. cp -a rootfs/* tmp-rootfs/
  222. umount -f "$BUILDDIR/tmp-rootfs"
  223. mkdir -p "$BUILDDIR/LiveOS"
  224. mksquashfs "$BUILDDIR/tmp" "$BUILDDIR/LiveOS/squashfs.img" \
  225. -comp ${COMPRESSTYPE} >>$LOGFILE 2>&1 || error_out
  226. chmod 444 "$BUILDDIR/LiveOS/squashfs.img" || error_out $?
  227. # Remove rootfs and temporary dirs, we don't need them anymore.
  228. rm -rf "$ROOTFS" "$BUILDDIR/tmp-rootfs" "$BUILDDIR/tmp" || error_out $?
  229. }
  230. generate_iso_image() {
  231. xorriso -as mkisofs \
  232. -iso-level 3 -rock -joliet \
  233. -max-iso9660-filenames -omit-period \
  234. -omit-version-number -relaxed-filenames -allow-lowercase \
  235. -volid "VOID_LIVE" \
  236. -eltorito-boot boot/isolinux/isolinux.bin \
  237. -eltorito-catalog boot/isolinux/boot.cat \
  238. -no-emul-boot -boot-load-size 4 -boot-info-table \
  239. -eltorito-alt-boot --efi-boot boot/grub/efiboot.img -no-emul-boot \
  240. -isohybrid-mbr /usr/share/syslinux/isohdpfx.bin \
  241. -output "$OUTPUT_FILE" "$BUILDDIR" >>$LOGFILE 2>&1 || error_out $?
  242. }
  243. #
  244. # main()
  245. #
  246. while getopts "C:c:l:o:r:s:h" opt; do
  247. case $opt in
  248. C) CONFIG_FILE="$OPTARG";;
  249. c) COMPRESSTYPE="$OPTARG";;
  250. l) LOCALREPO_PKGLIST="$OPTARG";;
  251. o) OUTPUT_FILE="$OPTARG";;
  252. r) ROOTDIR="$OPTARG";;
  253. s) SPLASH_IMAGE="$OPTARG";;
  254. h) usage;;
  255. esac
  256. done
  257. shift $(($OPTIND - 1))
  258. # Set defaults
  259. if [ -z "$CONFIG_FILE" ]; then
  260. CONFIG_FILE="$HOME/.mklive.conf"
  261. fi
  262. LOGFILE="$(mktemp -t vmklive-XXXXXXXXXX.log)"
  263. if [ -z "$SYSLINUX_DATADIR" ]; then
  264. SYSLINUX_DATADIR=/usr/share/syslinux
  265. fi
  266. if [ -z "$GRUB_DATADIR" ]; then
  267. GRUB_DATADIR=/usr/share/grub
  268. fi
  269. if [ -z "$MKLIVE_DATADIR" ]; then
  270. MKLIVE_DATADIR=/usr/share/void-mklive
  271. fi
  272. if [ -z "$SPLASH_IMAGE" ]; then
  273. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  274. fi
  275. if [ -z "$XBPS_INSTALL_CMD" ]; then
  276. XBPS_INSTALL_CMD=xbps-install
  277. fi
  278. if [ -z "$XBPS_REMOVE_CMD" ]; then
  279. XBPS_REMOVE_CMD=xbps-remove
  280. fi
  281. if [ -z "$XBPS_QUERY_CMD" ]; then
  282. XBPS_QUERY_CMD=xbps-query
  283. fi
  284. if [ -z "$XBPS_RINDEX_CMD" ]; then
  285. XBPS_RINDEX_CMD=xbps-rindex
  286. fi
  287. if [ -z "$XBPS_UHELPER_CMD" ]; then
  288. XBPS_UHELPER_CMD=xbps-uhelper
  289. fi
  290. if [ -z "$XBPS_RECONFIGURE_CMD" ]; then
  291. XBPS_RECONFIGURE_CMD=xbps-reconfigure
  292. fi
  293. if [ -z "$COMPRESSTYPE" ]; then
  294. COMPRESSTYPE=xz
  295. fi
  296. # Create or read configuration file.
  297. if [ ! -r $CONFIG_FILE ]; then
  298. info_msg "Creating config file at $CONFIG_FILE."
  299. write_conf_file $CONFIG_FILE
  300. fi
  301. . $CONFIG_FILE
  302. if [ -z "$PACKAGE_LIST" ]; then
  303. PACKAGE_LIST="base-system-live"
  304. else
  305. PACKAGE_LIST="base-system-live $PACKAGE_LIST"
  306. fi
  307. if [ ! -f $SYSLINUX_DATADIR/isolinux.bin ]; then
  308. echo "Missing required isolinux files in $SYSLINUX_DATADIR, exiting..."
  309. exit 1
  310. fi
  311. # Check for root permissions.
  312. if [ "$(id -u)" -ne 0 ]; then
  313. echo "Must be run as root, exiting..."
  314. exit 1
  315. fi
  316. ISO_VOLUME="VOID_LIVE"
  317. if [ -n "$ROOTDIR" ]; then
  318. BUILDDIR=$(mktemp --tmpdir="$ROOTDIR" -d) || exit 1
  319. else
  320. BUILDDIR=$(mktemp --tmpdir="$(pwd -P)" -d) || exit 1a
  321. fi
  322. BUILDDIR=$(readlink -f $BUILDDIR)
  323. ROOTFS="$BUILDDIR/rootfs"
  324. BOOT_DIR="$BUILDDIR/boot"
  325. ISOLINUX_DIR="$BOOT_DIR/isolinux"
  326. GRUB_DIR="$BOOT_DIR/grub"
  327. ISOLINUX_CFG="$ISOLINUX_DIR/isolinux.cfg"
  328. mkdir -p $ISOLINUX_DIR $GRUB_DIR
  329. #
  330. # Check there are repos registered before anything.
  331. #
  332. ${XBPS_QUERY_CMD} -L >/dev/null 2>&1
  333. if [ $? -ne 0 ]; then
  334. echo "No repositories available, exiting..."
  335. error_out
  336. fi
  337. XBPS_ARGS="-r $ROOTFS -y"
  338. if [ -n "$REPOSITORY_CACHE" ]; then
  339. XBPS_ARGS="$XBPS_ARGS -c $REPOSITORY_CACHE"
  340. fi
  341. XBPS_VERSION=$($XBPS_QUERY_CMD -V|awk '{print $2}')
  342. case $XBPS_VERSION in
  343. # XBPS >= 0.18
  344. [0-9].[1-9][8-9]*) ;;
  345. *) echo "Your xbps utilities are too old ($XBPS_VERSION), 0.18 is required." && exit 1;;
  346. esac
  347. KERNELVERSION=$($XBPS_QUERY_CMD -R --property version kernel)
  348. if [ -z "$OUTPUT_FILE" ]; then
  349. OUTPUT_FILE="$HOME/void-live-$(uname -m)-${KERNELVERSION}-$(date +%Y%m%d).iso"
  350. fi
  351. info_msg "Redirecting stdout/stderr to $LOGFILE ..."
  352. #
  353. # Install live system and specified packages.
  354. #
  355. info_msg "[1/9] Installing packages into the rootfs..."
  356. install_packages
  357. #
  358. # Prepare /etc/motd.
  359. #
  360. mkdir -p "$ROOTFS"/etc
  361. write_etc_motd
  362. #
  363. # Generate the initramfs.
  364. #
  365. info_msg "[2/9] Generating initramfs image ($COMPRESSTYPE)..."
  366. generate_initramfs
  367. #
  368. # Copy linux kernel and modules to rootfs.
  369. #
  370. info_msg "[3/9] Copying kernel image/modules from temporary rootfs..."
  371. copy_kernel_and_modules
  372. #
  373. # Generate the package local repository for void-installer.
  374. #
  375. if [ -z "$LOCALREPO_PKGLIST" ]; then
  376. _skip="(disabled)"
  377. fi
  378. info_msg "[4/9] Generating package local repository ${_skip}..."
  379. if [ -n "$LOCALREPO_PKGLIST" ]; then
  380. generate_local_repository
  381. fi
  382. #
  383. # Generate the isolinux boot.
  384. #
  385. info_msg "[5/9] Generating isolinux support for PC-BIOS systems..."
  386. generate_isolinux_boot
  387. #
  388. # Generate the GRUB EFI boot.
  389. #
  390. info_msg "[6/9] Generating GRUB support for EFI systems..."
  391. generate_grub_efi_boot
  392. #
  393. # Generate the squashfs image from rootfs.
  394. #
  395. info_msg "[7/9] Generating squashfs image ($COMPRESSTYPE) from rootfs..."
  396. generate_squashfs
  397. #
  398. # Generate the ISO image.
  399. #
  400. info_msg "[8/9] Generating ISO image..."
  401. generate_iso_image
  402. info_msg "[9/9] Removing build directory..."
  403. rm -rf "$BUILDDIR" || error_out $?
  404. hsize=$(du -sh "$OUTPUT_FILE"|awk '{print $1}')
  405. info_msg "Created $(readlink -f $OUTPUT_FILE) ($hsize) successfully."
  406. exit 0